{$reference system.windows.forms.dll}
{$reference System.Drawing.dll}
uses
  System.Windows.Forms, System.Drawing, OpenGl, BMtGL;

var
  RotXSp, RotYSp,RotX,RotY,MW: Single;
  WW, WH: integer;
  n: byte;
  _hdc: HDC;
  textures:= new integer[1];

procedure glGenTextures(n:integer;textures:pointer);
external 'OpenGL32.dll' name 'glGenTextures';

procedure glBindTexture(target:GLenum;texture:GLuint);
external 'OpenGL32.dll' name 'glBindTexture';

procedure glEnableClientState(arr:GLenum);
external 'OpenGL32.dll' name 'glEnableClientState';

procedure glVertexPointer(sz:integer;T:GLenum;stride:integer;p:pointer);
external 'OpenGL32.dll' name 'glVertexPointer';

procedure glTexCoordPointer(sz:integer;T:GLenum;stride:integer;p:pointer);
external 'OpenGL32.dll' name 'glTexCoordPointer';

procedure glDrawElements(mode:GLenum;count:integer;T:GLenum;p:pointer);
external 'OpenGL32.dll' name 'glDrawElements';

type
  GraphField = class(PictureBox)
    timer: Timer;
    components: System.ComponentModel.IContainer;
    
    procedure MouseStay;
    var
      MP := System.Windows.Forms.Cursor.Position;
    begin
      RotXSp *= 0.95;
      RotYSp *= 0.95;
      MW *= 0.95;
      
      RotX += RotXSp;
      RotY += RotYSp;
      
      if RotX > 90 then RotX := 90;
      if RotX < -90 then RotX := -90;
      
      while RotY > 180 do RotY -= 360;
      while RotY < -180 do RotY += 360;
      
      RotXSp -= (WH / 2 - MP.Y) * 0.05;
      RotYSp -= (WW / 2 - MP.X) * 0.05;
      System.Windows.Forms.Cursor.Position := new Point(WW div 2, WH div 2);
      
      gluLookAt(0.0, 0.0, MW/100,  0.0, 0.0, -1.0,  0.0, 1.0, 0.0);
    end;
    
    procedure TimerTick(sender: Object; e: system.EventArgs);
    begin
      if n = 0 then
        Milliseconds;
        
      glClearColor(single(0.0), single(0.0), single(0.0), single(0.0));
      glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
      
      glTranslatef(0, 0, 0);
      glPushMatrix;
      glRotatef(RotX, 1.0, 0.0, 0.0);
      glRotatef(RotY, 0.0, 1.0, 0.0);
      
      {}
      glColor4f(1, 0, 0, 0.5);
      glBindTexture(GL_TEXTURE_2D,textures[0]);
      glBegin(GL_QUADS);
      glTexCoord2f(0.0,0.0);glVertex3f(-1, -1, -1);
      glTexCoord2f(1.0,0.0);glVertex3f(+1, -1, -1);
      glTexCoord2f(1.0,1.0);glVertex3f(+1, -1, +1);
      glTexCoord2f(0.0,1.0);glVertex3f(-1, -1, +1);
      glEnd;
      glBindTexture(GL_TEXTURE_2D,0);
      {}
      
      {}
      glBegin(GL_QUADS);
      glColor4f(1, 0, 0, 1);
      //glVertex3f(-1, -1, -1); glVertex3f(+1, -1, -1); glVertex3f(+1, -1, +1); glVertex3f(-1, -1, +1);
      glVertex3f(-1, +1, -1); glVertex3f(+1, +1, -1); glVertex3f(+1, +1, +1); glVertex3f(-1, +1, +1);
      
      glColor3f(0, 1, 0);
      glVertex3f(-1, -1, -1); glVertex3f(+1, -1, -1); glVertex3f(+1, +1, -1); glVertex3f(-1, +1, -1);
      glVertex3f(-1, -1, +1); glVertex3f(+1, -1, +1); glVertex3f(+1, +1, +1); glVertex3f(-1, +1, +1);
      
      glColor3f(0, 0, 1);
      glVertex3f(-1, -1, -1); glVertex3f(-1, +1, -1); glVertex3f(-1, +1, +1); glVertex3f(-1, -1, +1);
      glVertex3f(+1, -1, -1); glVertex3f(+1, +1, -1); glVertex3f(+1, +1, +1); glVertex3f(+1, -1, +1);
      
      
      glColor3f(1, 0, 0);
      glVertex3f(-0, -0, -0); glVertex3f(+2, -0, -0); glVertex3f(+2, -0, +2); glVertex3f(-0, -0, +2);
      glVertex3f(-0, +2, -0); glVertex3f(+2, +2, -0); glVertex3f(+2, +2, +2); glVertex3f(-0, +2, +2);
      
      glColor3f(0, 1, 0);
      glVertex3f(-0, -0, -0); glVertex3f(+2, -0, -0); glVertex3f(+2, +2, -0); glVertex3f(-0, +2, -0);
      glVertex3f(-0, -0, +2); glVertex3f(+2, -0, +2); glVertex3f(+2, +2, +2); glVertex3f(-0, +2, +2);
      
      glColor3f(0, 0, 1);
      glVertex3f(-0, -0, -0); glVertex3f(-0, +2, -0); glVertex3f(-0, +2, +2); glVertex3f(-0, -0, +2);
      glVertex3f(+2, -0, -0); glVertex3f(+2, +2, -0); glVertex3f(+2, +2, +2); glVertex3f(+2, -0, +2);
      
      glEnd;
      {}
      glPopMatrix;
      
      MouseStay;
      
      glFlush;
      SwapBuffers(_hdc);
      
      n += 1;
      if n >= 60 then
      begin
        writeln(MillisecondsDelta);
        n := 0;
      end;
    end;
    
    constructor(x, y, w, h, I: integer);
    begin
      self.Left := x;
      self.top := y;
      self.Width := w;
      self.Height := h;
      components := new System.ComponentModel.Container;
      timer := new System.Windows.Forms.Timer(self.components);
      SuspendLayout();
      timer.Enabled := true;
      timer.Interval := I;
      _hdc := GetDC(self.Handle.ToInt32());
      OpenGLInit(self.Handle);
      
      glEnable(GL_TEXTURE_2D);
      glShadeModel(GL_SMOOTH);
      
      glEnable(GL_DEPTH_TEST);
      glDepthFunc(GL_LEQUAL);
      glClearDepth(1.0);
      glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
      
      glEnable(GL_BLEND);
      glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      
      glGenTextures(1,@textures[0]);
      
      var tw,th:integer;
      var texture0 := LoadOpenGLImage('1.bmp',@tw,@th,RGB);
      glBindTexture(GL_TEXTURE_2D,textures[0]);
      glTexImage2D(GL_TEXTURE_2D,0,GL_RGB, tw, th, 0, GL_RGB, GL_UNSIGNED_BYTE, @texture0);
      //glGenerateMipmap(GL_TEXTURE_2D);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
      glBindTexture(GL_TEXTURE_2D, 0); 

      
      glMatrixMode( GL_PROJECTION );
      glLoadIdentity;
      glViewport(0, 0, Width, Height);
      gluPerspective(45.0, Width / Height, 0.1, 1000.0);
      
      glMatrixMode( GL_MODELVIEW );
      glLoadIdentity;
      gluLookAt(0.0, 0.0, 20.0,  0.0, 0.0, 0.0,  0.0, 1.0, 0.0);
      
      System.Windows.Forms.Cursor.Position := new Point(WW div 2, WH div 2);
      Cursor.Dispose;
      timer.Tick += TimerTick;
      
      
      //MW := 240;
      
      //glGenTextures;
    end;
  end;

var
  MF: System.windows.forms.Form;
  GF: GraphField;

function GetDesktopWindow: system.IntPtr;external 'User32.dll' name 'GetDesktopWindow';

procedure GetWindowRect(hWnd: system.IntPtr; var lpRect: system.Drawing.Rectangle);external 'User32.dll' name 'GetWindowRect';

procedure OnMouseWheel(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  MW += e.Delta;
  writeln(MW);
end;
    
begin
  MF := new Form;
  MF.WindowState := FormWindowState.Maximized;
  MF.FormBorderStyle := system.windows.forms.FormBorderStyle.None;
  begin
    var a: system.Drawing.Rectangle;
    GetWindowRect(GetDesktopWindow, a);
    WW := a.Width;
    WH := a.Height;
  end;
  GF := new GraphField(0, 0, WW, WH, 15);
  MF.Controls.Add(GF);
  system.windows.forms.Application.Run(MF);
  MF.MouseWheel += OnMouseWheel;//  ToDO
end.